var _edict = false;

try {
  _edict = org.mozdev.moji.dict.EDict;
} catch (e)
{
  try {
    _edict = EDict;
  } catch (e) { }
}

if ( _edict )
 _edict.prototype.mojijpnam = {
  _analyzeEntry : function(ent) {
    var ret = { terms: new Array(), meanings: new Array() };
    ret.meanings[0] = { terms: new Array(), translations: new Array() };
    
    var parts = ent.split("/");
    
    for ( var i = 0; i < parts.length; i++ ) {
      // skip empty entries (at the beginning and the end...)
      if ( parts[i] == "" )
        continue;
      
      var tags = parts[i].match(/\(.(,.)*\)/g);
      
      if ( tags )
        for ( var j = 0; j < tags.length; j++ ) {
          var alltags = tags[j].substr(1, tags[j].length-2);
          var tag = alltags.split(",");
          var terms = Array();
          
          for ( var k = 0; k < tag.length; k++ ) {
            var f;
            
            switch ( tag[k] ) {
              case "s": f = "surname"; break;
              case "p": f = "place-name"; break;
              case "u": f = "person name, as-yet unclassified"; break;
              case "g": f = "given name, as-yet not classified by sex"; break;
              case "f": f = "female given name"; break;
              case "m": f = "male given name"; break;
              case "h": f = "full (family plus given) name of a particular person"; break;
	      case "pr": f = "product name"; break;
	      case "co": f = "company name"; break;
	      case "st": f = "stations"; break;
              default: full = "unknown tag " + tag[k];
            }
            
            terms.push({abbrev: tag[k], full: f});
          }
         
          ret.meanings[0].terms.push(terms);
        }

      // remove any tags at the beginng of this part including following spaces
      parts[i] = parts[i].replace(/^\(.(,.)*\) +/, "");
      // and also remove any tags including spaces before it.
      parts[i] = parts[i].replace(/ +\(.(,.)*\)/, "");
      
      if ( parts[i].length > 0 )
        ret.meanings[0].translations.push(parts[i]);
    }    

    return ret;
  }
}
